image: python:3.12

services:
  - name: postgis/postgis:latest
    alias: postgres

variables:
  POSTGRES_DB: "db_name"
  POSTGRES_USER: "db_user"
  POSTGRES_PASSWORD: "db_pwd"
  POSTGRES_HOST: "postgres"
  POSTGRES_PORT: "5432"
  # SECRET_KEY: "neidePhaeL*oh3quoo9uig3Tho3exi>iki9af3Eech<iep4eic"

stages:
  - lint
  - run


before_script:
  - apt update && apt install -y libgraphviz-dev libgdal32
  - pip install poetry
  - poetry config virtualenvs.create false
  - poetry install


Python Code Lint:
  stage: lint
  script:
    - poetry run black .
    - poetry run isort --profile black --filter-files .

test-job:
  stage: run
  script:
    - echo "Activating virtual environment..."
    - echo "Running unit tests..."
    - cp .env.sample .env
    - poetry run python -m manage migrate
    - poetry run python -m manage runserver &
    - sleep 10
    - curl -sSf http://localhost:8000 > /dev/null && echo "Server is Up"
    - pkill python
    - echo "All tests successfully passed."
